<template>
  <base-card>
    <h2>Find Your Coach</h2>
    <span class="filter-option">
      <input type="checkbox" id="frontend" checked @change="setFilter" />
      <label for="frontend">Frontend</label>
    </span>
    <span class="filter-option">
      <input type="checkbox" id="backend" checked @change="setFilter" />
      <label for="backend">Backend</label>
    </span>
    <span class="filter-option">
      <input type="checkbox" id="career" checked @change="setFilter" />
      <label for="career">Career</label>
    </span>
  </base-card>
</template>

<script lang='ts'>
// import { ref } from 'vue';

export default {
  emits: ['change-filter'],
  data() {
    return {
      filters: {
        frontend: true,
        backend: true,
        career: true
      }
    };
  },
  methods: {
    setFilter(event: Event) {
      const inputId = (event.target as HTMLInputElement).id;
      const isActive = (event.target as HTMLInputElement)?.checked;
      const updatedFilters = {
        ...this.filters,
        [inputId]: isActive
      };
      this.filters = updatedFilters;
      this.$emit('change-filter', updatedFilters);
    }
  }
  // setup(_, { emit }) {
  //   const filters = ref({
  //     frontend: true,
  //     backend: true,
  //     career: true
  //   });

  //   const setFilter = (event: Event) => {
  //     const inputId = (event.target as HTMLInputElement).id;
  //     const isActive = (event.target as HTMLInputElement)?.checked;
  //     filters.value = {
  //       ...filters.value,
  //       [inputId]: isActive
  //     };
  //     emit('change-filter', filters.value);
  //   };

  //   return {
  //     filters,
  //     setFilter
  //   };
  // }
}
</script>
<!-- <script setup lang='ts'>
import { ref, defineEmits } from 'vue';

const emit = defineEmits({
  changeFilter: (value) => value !== null,
});
const filters = ref({
  frontend: true,
  backend: true,
  career: true
});
const setFilter = (event: Event) => {
  const inputId = (event.target as HTMLInputElement).id;
  const isActive = (event.target as HTMLInputElement)?.checked;
  filters.value = {
    ...filters.value,
    [inputId]: isActive
  };

  emit('changeFilter', filters.value);
};
</script> -->

<style scoped>
h2 {
  margin: 0.5rem 0;
}

.filter-option {
  margin-right: 1rem;
}

.filter-option label,
.filter-option input {
  vertical-align: middle;
}

.filter-option label {
  margin-left: 0.25rem;
}

.filter-option.active label {
  font-weight: bold;
}
</style>